/*******************************************************************
 *	Copyright (c) 1994-1999 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: alg.h
 *	Created:
 *	Revision:
 *
 *	Description: IOCTL wrappers for BestCrypt Driver
.
 *
 *******************************************************************/


#ifndef __ALG_H__
#define __ALG_H__

#include <bc_ioctl.h>

#ifdef CPLUSPLUS
extern "C" {
#endif

/* all these functions return 0 upon success ERROR_CODE otherwise */

extern int alg_verify	(ALG_SERV Alg);

extern int alg_make_key	(ALG_SERV Alg,
			BYTE	*key, 
			DWORD	key_len, /* bits */
			BYTE	*pool,
			KEY_HANDLE *key_handle);

extern int alg_free_key	(ALG_SERV Alg,
			KEY_HANDLE key_handle);
								
extern int alg_encrypt	(ALG_SERV Alg,
			KEY_HANDLE key_handle,
			BYTE	*iv,
			BYTE	*buffer,
			DWORD	buffer_len);
				
extern int alg_decrypt	(ALG_SERV Alg,
			KEY_HANDLE key_handle,
			BYTE	*iv,
			BYTE	*buffer,
			DWORD buffer_len);

extern int bc_set_fd	(ALG_SERV Alg,
			BYTE	*key, 
			DWORD	key_len, /* bits */
			BYTE	*pool,
			int fd,
			int offset,
			unsigned int flags);
				
extern int bc_set_fd_kh	(ALG_SERV Alg,
			KEY_HANDLE key_handle,
			int fd,
			int offset,
			unsigned int flags);

extern int bc_clear_fd	(ALG_SERV Alg);

/* bc_get_info returns 0 if device is free, 1 otherwise */
extern int bc_get_info	(ALG_SERV Alg, int *ver_major, int *ver_minor);

/* bc_(un)lock_dev returns 0 upon success error code if error occured */
/* bc_(un)lock_dev is protected safely from multiple calls */
extern int bc_lock_dev	(ALG_SERV Alg);
extern int bc_unlock_dev(ALG_SERV Alg);

#ifdef CPLUSPLUS
}
#endif
#endif /* __ALG_H__ */
