/*******************************************************************
*
*      Copyright (c) 1994-1999 Jetico, Inc., Finland
*      All rights reserved.
*
*      File: bcinfo.c
*      Revision:
*      Created:
*      Description: implementation of container info routine
*
*******************************************************************/


#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include "header.h"
#include "config.h"
#include "bctool.h"
#include "misc.h"
#include "error.h"

void bcinfo (int argc, char ** argv)
{

   struct HiddenSector 	hs;
   int fd;
   alg_info *alg_inf;
   char *algorithm,*fsys;
   
   if (argc < 2){ 
      fprintf(stderr,"Please specify container name\n"); 
      exit(0); 
   } else if (argc > 2 ){
      fprintf(stderr,"Too many parameters\n");
      exit(0);
   }
    
   if ((fd = open(argv[1], O_RDONLY)) < 0){ 
      perror (argv[1]);
      exit (0); 
   }
   if (read(fd, &hs, sizeof(hs))!=sizeof(hs)){
      fprintf(stderr,"Can not read container header\n");
      exit (0); 
   }
   if (strncmp(hs.br.OEMid, "LOCOS94 ", sizeof(hs.br.OEMid))!=0){
      fprintf(stderr,"%s is not valid BestCrypt container\n",argv[0]);
      exit (0);
    };   
   if ((alg_inf=GetInfoById(hs.algorithmId))==NULL)
     algorithm="Unknown algorithm";
   else algorithm=alg_inf->alg_name;
   if ((fsys=getFStypeById(hs.fileSystemId))==NULL)
     fsys="Unknown filesystem";

   printf("Description: %s\nEncryption Algorithm: %s\nFilesystem: %s\n",
	  hs.description,algorithm,fsys);
   
   close(fd);
}

