/*******************************************************************
*
*      Copyright (c) 1994-1999 Jetico, Inc., Finland
*      All rights reserved.
*
*      File: bccreate.c
*      Revision:
*      Created:
*      Description: implementation of error printing routine
*
*******************************************************************/
 


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <bc_error.h>
#include <kg_defs.h>
#include "misc.h"
#include "config.h"

char err_str[255];

void print_error (int error){

   switch (error){
    case ERROR_NO:
      sprintf(err_str,"no errors\n");break;
// Kgsha errors
    case ERROR_INTERNAL_PROBLEM:
      sprintf(err_str,"Kgsha: Internal problems\n");break;
    case ERROR_INVALID_ALGORITHM:
      sprintf(err_str,"Kgsha: Invalid algorithm\n");break;
    case ERROR_INCORRECT_CREATE_FLAG:
      sprintf(err_str,"Kgsha: Icorrect create flag\n");break;
    case ERROR_INCORRECT_FORMAT_VERSION:
      sprintf(err_str,"Kgsha: Icorrect format version\n");break;
    case ERROR_INCORRECT_BLOCK_SIGNATURE:
      sprintf(err_str,"Kgsha: Icorrect block signature\n");break;
    case ERROR_DAMAGED_DATA_BLOCK:
      sprintf(err_str,"Kgsha: Damaged date block\n");break;
    case ERROR_CANCELLED_BY_USER:
      sprintf(err_str,"Kgsha: Cancelled by user\n");break;
    case ERROR_USER_PASSWORDS_MISMATCH:
      sprintf(err_str,"Kgsha: Password mismatch\n");break;
    case ERROR_INCORRECT_PASSWORD:
      sprintf(err_str,"Kgsha: Password incorrect\n");break;
    case ERROR_NOT_ENOUGH_INIT_KEYS:
      sprintf(err_str,"Kgsha: Not enough init keys\n");break;
    case ERROR_INCORRECT_ENCR_ALGORITHM:
      sprintf(err_str,"Kgsha: Incorrect encryption algorithm\n");break;
    case ERROR_INCORRECT_HASH_ALGORITHM:
      sprintf(err_str,"Kgsha: Incorrect hash algorithm\n");break;
    case ERROR_INCORRECT_DATA_BLOCK_SIZE:
      sprintf(err_str,"Kgsha: Incorrect datablock size\n");break;
    case ERROR_NOT_ENOUGH_SPACE_FOR_KEY:
      sprintf(err_str,"Kgsha: Not enough space for key\n");break;
    case ERROR_INCORRECT_POOL:
      sprintf(err_str,"Kgsha: Incorrect pool\n");break;

// Config errors
    case FATAL_ERROR:
      sprintf(err_str,"Config: Fatal error\n");break;
    case NO_MEM:
      sprintf(err_str,"Config: Not enough memory\n");break;
    case CONF_BAD_FNAME:
      sprintf(err_str,"Config: Can not open config file\n");break;
    case CONF_FOPEN_ERR:
      sprintf(err_str,"Config: Error while opening config file\n");break;
    case CONF_BAD_FILE:
      sprintf(err_str,"Config: Bad config file\n");break;
    case TOKEN_FATAL:
      sprintf(err_str,"Config: Token fatal error\n");break;
    case TOKEN_TRUNC:
      sprintf(err_str,"Config: Token truncated\n");break;
    case TOKEN_BAD:
      sprintf(err_str,"Config: Bad token\n");break;
    case TOKEN_EMPTY:
      sprintf(err_str,"Config: Token empty\n");break;

// Driver errors 
    case BC_DEV_NO_MEM:
      sprintf(err_str,"Driver: Not enough memory\n");break;
    case BC_MGR_NO_MEM:
      sprintf(err_str,"Driver: Not enough memory\n");break;
    case BC_ALG_NO_MEM:
      sprintf(err_str,"Driver: Not enough memory\n");break;
    case BC_ALG_NO_ALG:
      sprintf(err_str,"Driver: Unknown algorithm\n");break;
    case BC_ALG_NO_KEY:
      sprintf(err_str,"Driver: No key\n");break;
    case BC_ALG_NO_DATA:
      sprintf(err_str,"Driver: No data\n");break;
    case BC_ALG_BAD_KEY:
      sprintf(err_str,"Driver: Bad key\n");break;
    case BC_ALG_BAD_DATA:
      sprintf(err_str,"Driver: Bad data\n");break;

    default:
            msg(stderr,strerror(error));return;
   }
      msg(stderr,err_str);
}

